package client;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import java.io.*;


import common.ChatClient;
import common.ChatServer;

public class ChatClientImpl extends UnicastRemoteObject
    implements ChatClient, Runnable {

    private ChatServer mycs;

    public ChatClientImpl( ChatServer cs ) throws java.rmi.RemoteException {
	mycs = cs;
	mycs.register( this );
    }


    public synchronized void receive( String s ) throws java.rmi.RemoteException {
	System.out.println("Message: " + s );
    }


    public void run() {
	BufferedReader ir
	    = new BufferedReader(new InputStreamReader(System.in));
	String msg;

	while( true ) {
	    try {
		System.out.println("Enter a message sometime...");
		msg = ir.readLine();
		System.out.println("Broadcasting message: " + msg );

		mycs.broadcast( msg );
	    } catch( Exception e ) {
		System.err.println("Client had a problem...");
		e.printStackTrace();
	    }
	}
    }


    public static void main( String[] args ) {
	String url = "rmi://gem/ChatServer";

	try {
	    ChatServer cs = (ChatServer) Naming.lookup( url );
	    new Thread(new ChatClientImpl( cs )).start();
	} catch( Exception e ) {
	    System.err.println("Client had a startup problem...");
	    e.printStackTrace();
	}

    }

}
