package server;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import java.util.*;


import common.ChatServer;
import common.ChatClient;


public class ChatServerImpl extends UnicastRemoteObject
    implements ChatServer {

    private LinkedList myclients;


    public ChatServerImpl() throws java.rmi.RemoteException {
	myclients = new LinkedList();
    }


    public synchronized void register( ChatClient c )  throws java.rmi.RemoteException {

	System.out.println("Registering a new client...");
	myclients.add( c );
    }


    public synchronized void broadcast( String s ) throws java.rmi.RemoteException {
	ListIterator it = myclients.listIterator(0);
	ChatClient c;
	int i = 0;

	System.out.println("Broadcast called...");

	while( it.hasNext() ) {
	    c = (ChatClient) it.next();

	    System.out.println("Sending message to client " + ++i);
	    c.receive( s );
	}
    }

    public static void main( String[] args ) {
	try {
	    Naming.rebind( "ChatServer", new ChatServerImpl( ) );
	} catch( Exception ex ) {
	    System.err.println("Binding the server failed!");
	    ex.printStackTrace();
	}
    }

}
