import java.util.Random;

public class Philosoph extends Thread {
    private Tisch t;
    private int id;
    private Random rnd;

  Philosoph(Tisch tt, int i) {
    t = tt;
    id = i;
    rnd = new Random( id );
  }

  private void denken() {
      System.out.println("Philosoph " + id + " denkt...");

      try { Thread.sleep(rnd.nextInt(10) * 1); }
      catch(InterruptedException e) {}

      System.out.println("Philosoph " + id + " hat genug gedacht...");
  }

  private void essen() {
      System.out.println("Philosoph " + id + " isst...");

      try { Thread.sleep(rnd.nextInt(10) * 1); }
      catch(InterruptedException e) {}

      System.out.println("Philosoph " + id + " hat genug gegessen...");
  }

  public void run() {
      int first, second;

      first = id < ((id+1) % t.n) ? id : (id+1) % t.n;
      second = id < ((id+1) % t.n) ? (id+1) % t.n : id;

      while (true) {
	  denken();

	  t.gabel[first].belegen(first);
	  t.gabel[second].belegen(second);

	  essen();

	  t.gabel[first].freigeben(first);
	  t.gabel[second].freigeben(second);
      }
  }
}
