import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class GuiChangeObserver implements java.util.Observer {


    public void update( java.util.Observable source, Object event ) {

	if( ! (event instanceof ChangeEvent) ) return;

	ChangeEvent ce = (ChangeEvent) event;

	if( ce instanceof IncreaseEvent ) {
	    sign.setForeground( Color.RED );
	    sign.setText("++++");
	    value.setText("New Value: " + ce.getValue());
	    change.setText("Change: " + ce.getChange());
	} else {
	    sign.setForeground( Color.BLUE );
	    sign.setText("----");
	    value.setText("New Value: " + ce.getValue());
	    change.setText("Change: " + ce.getChange());
	}
    }


    private JLabel sign = new JLabel();
    private JLabel value = new JLabel();
    private JLabel change = new JLabel();


    public Component createComponents() {

        JPanel pane = new JPanel();
        pane.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        30, //bottom
                                        30) //right
                                        );
        pane.setLayout(new GridLayout(0, 3));

        pane.add(sign);
	pane.add(value);
	pane.add(change);

        return pane;
    }



    public GuiChangeObserver() {

	try {
	    UIManager.setLookAndFeel(
		       UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) { }



       //Create the top-level container and add contents to it.
        JFrame frame = new JFrame("Active Value Output");

        Component contents = createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.pack();
	frame.setSize( 500, 150 );



        frame.setVisible(true);
    }

}
